Subject: bug#24640: Crashes in 25.1

From: Eli Zaretskii <[email-masked]>
Date: Sun, 09 Oct 2016 12:57:34 +0300

> From: Reuben Thomas <[email-masked]>
> Date: Sun, 9 Oct 2016 08:45:08 +0100
> Cc: [email-masked]
> 
>  The only efficient way to speed up debugging (or rather to make sure
>  it succeeds at all) is for you to come up with a reproducible recipe
>  and post here all the files needed for reproducing the crashes.
> 
> ​That would seem to require me to bisect my .desktop and potentially post dozens of personal files, so doesn't
> seem feasible.​

If you just start a fresh session, save its desktop, then restart it,
while using the lazy-load feature, does it start normally?  Maybe all
that's needed is to do this, with no personal files involved.

> I thought it might be faster for you to drive a debugging session live than to engage in
> back-and-forth by email.

It would require me to explain too many things, so it won't be
efficient enough.

>  >From what I see in the backtraces, your setup fires a timer that runs
>  some complicated Lisp, and that Lisp somehow corrupts some Lisp
>  objects, which then cause crashes during GC.
> 
> ​You make it sound as though this is some arcane personal setup, when in fact I am simply using desktop.el!

So do I, but it never crashes for me.  Nor did we have such crash
reports until now.  So there's something you do that I and others
don't, although I didn't mean (and didn't say AFAIK) that it's
something arcane.

>  And the first step is
>  to stop using an optimized build, because it makes debugging much
>  harder if not impossible.
> 
> I'll see if, having rebuilt from source without optimisation, the bug still fires.​
> 
>  If you are willing to try the debugging yourself, there's some advice
>  in etc/DEBUG (search for "Debugging problems which happen in GC").
> 
> ​I'll have a look.​

Thanks.

>  Do I understand correctly that this worked for you with Emacs 24.5?
> 
> ​Yes, the identical setup loads fine in 24.5. I've never seen this sort of crash before.​

Does Emacs crash when restoring a desktop file written by Emacs 24.5,
or only when it restores files written by Emacs 25?